local require = GLOBAL.require
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local STRINGS = GLOBAL.STRINGS

PrefabFiles = 
{
	"floe",
	"frozen_book",
	"floeringfx",
}

Assets = {
    Asset( "ATLAS", "images/saveslot_portraits/floe.xml" ),
    Asset( "IMAGE", "images/saveslot_portraits/floe.tex" ),
	
	Asset( "ATLAS", "images/selectscreen_portraits/floe.xml" ),
    Asset( "IMAGE", "images/selectscreen_portraits/floe.tex" ),
	
	Asset( "ATLAS", "images/selectscreen_portraits/floe_silho.xml" ),
    Asset( "IMAGE", "images/selectscreen_portraits/floe_silho.tex" ),
	
	Asset( "ATLAS", "bigportraits/floe.xml" ),
    Asset( "IMAGE", "bigportraits/floe.tex" ),
	
	Asset( "ATLAS", "images/floe.xml"),
	Asset( "IMAGE", "images/floe.tex"),
	
--	Asset( "ATLAS", "images/floe_warm.xml"),
--	Asset( "IMAGE", "images/floe_warm.tex"),
}

local icespike_floe =
    {
        name = "icespike_floe",
        bank = "deerclops_icespike",
        build = "icespike_floe",
        anim = "spike2",
    }
 
GLOBAL.table.insert(GLOBAL.require("fx"), icespike_floe)

local icemorpher =
    {
        name = "icemorpher",
        bank = "frozen_shatter",
        build = "icemorpher",
        anim = "small",
    }
 
GLOBAL.table.insert(GLOBAL.require("fx"), icemorpher)

local function ModMaxwellIntro(inst)
    if GLOBAL.GetPlayer().prefab == "floe" then
        inst.components.maxwelltalker.speeches.SANDBOX_1 =
        {
            appearsound = "dontstarve/maxwell/disappear",
	        voice = "dontstarve/maxwell/talk_LP",
		    appearanim = "appear",
		    idleanim= "idle",
		    dialogpreanim = "dialog_pre",
		    dialoganim="dial_loop",
		    dialogpostanim = "dialog_pst",
		    disappearanim = "disappear",
            disableplayer = true,
            skippable = false,
            {
                string = "Wloe. Not so self confident anymore?",
                wait = 4,
                anim = nil,
                sound = nil,
            },
            {
                string = "You think that you can be more cheeky than me! Ha!",
                wait = 4,
                anim = nil,
                sound = nil,
            },
            {
                string = "Only I can rule!",
                wait = 4,
                anim = nil,
                sound = nil,
            },
            {
                string = "Bow before me and maybe I'll let you go! ",
                wait = 4,
                anim = dialog1_loop,
                sound = nil,
            },
	}
    end
end

AddPrefabPostInit("maxwellintro", ModMaxwellIntro)

AddModCharacter("floe")
table.insert(GLOBAL.CHARACTER_GENDERS.FEMALE, "floe")

AddMinimapAtlas("images/floe.xml")

--[[	if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) then 
local function AoSFix(inst) 
inst:AddComponent("switch") 
end 
    end

for _, moddir in ipairs(GLOBAL.KnownModIndex:GetModsToLoad()) do 
if GLOBAL.KnownModIndex:GetModInfo(moddir).name == "Always On Status" then 
AddPrefabPostInit("floe", AoSFix) 
end 
end]]

table.insert(Assets, Asset("ANIM", "anim/healthf.zip"))

local function FloeHealthBadge(class)
	if GLOBAL.GetPlayer().prefab == "floe" then

	class.heart.anim:GetAnimState():SetBuild("healthf")
	
	end
end

AddClassPostConstruct("widgets/statusdisplays", FloeHealthBadge)

