local MakePlayerCharacter = require "prefabs/player_common"

local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/maxwell.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),

        Asset( "ANIM", "anim/floe.zip" ),	
        Asset( "ANIM", "anim/floe_summer.zip" ),		
}

local prefabs = {"icemorpher",}

local start_inv = {"bluegem", "frozen_book",}	

local function regenaura(inst)

	local gamer = GetPlayer()

    if (gamer.components.health and gamer.components.health:IsHurt()) then
        gamer.components.health:DoDelta(1,false,"redamulet")
    end
end

local function tempcontrol(inst, data)
		
	if inst.state == "weak" then
		
		--[[if inst.components.recovery then
				 inst:RemoveComponent("recovery")
		end]]
	if inst.task then inst.task:Cancel() inst.task = nil end
	
		if inst.components.temperature.current < 25 then
			inst.components.combat.damagemultiplier = 1.1
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.1)
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.1)

			inst.components.talker.colour = Vector3(.4, .6, .9, 0)
			inst.AnimState:SetBuild("floe")
			--inst.MiniMapEntity:SetIcon( "floe.tex" )

					local fx = SpawnPrefab("icemorpher")
						if fx then
							fx.Transform:SetPosition(inst:GetPosition():Get())
							fx.AnimState:SetScale(1,1,1)
						end

					fx = SpawnPrefab("icemorpher")
						if fx then
							fx.Transform:SetPosition(inst:GetPosition():Get())
							fx.AnimState:SetScale(1,1,1)
						end
						
			inst.state = "frozen"	
		end
	end
	
	if inst.state == "frozen" then	
	
	--[[	if not inst.components.recovery then
			inst:AddComponent("recovery")
		end]]
		if not inst.task then
		inst.task = inst:DoPeriodicTask(10, function() regenaura(inst) end)
		end
		
		if inst.components.temperature.current >= 25 then
			inst.components.combat.damagemultiplier = 1
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1)
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1)
			
			inst.components.talker.colour = Vector3(.9, .1, .1, 0)
			inst.AnimState:SetBuild("floe_summer")
		--	inst.MiniMapEntity:SetIcon( "floe_warm.tex" ) 
					local fx = SpawnPrefab("icemorpher")
						if fx then
							fx.Transform:SetPosition(inst:GetPosition():Get())
							fx.AnimState:SetScale(1,1,1)
						end

					fx = SpawnPrefab("icemorpher")
						if fx then
							fx.Transform:SetPosition(inst:GetPosition():Get())
							fx.AnimState:SetScale(1,1,1)
						end
			inst.state = "weak"
		end
	end
end
	

local function tempcheck(inst)
	
	local CheckTempTime = 1.8

	inst.checkwloetemperature = inst:DoPeriodicTask(CheckTempTime, function() tempcontrol(inst) end)

	end

	
local fn = function(inst)
	inst:AddComponent("reader")
	
	inst.soundsname = "Wallace"
    inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "floe.tex" )
	
	inst.components.health.fire_damage_scale = 2	
    inst.components.health:SetMaxHealth(100)	
	inst.components.sanity:SetMax(200)
	
	inst.components.temperature.maxtemp = ( 100 )
	inst.components.temperature.mintemp = ( 12 )	
--	inst.SpawnPrefab("icespike_floe")
	inst.state = "frozen"
	
	if not inst.checkwloetemperature then
		tempcheck(inst)
	end
		

	
end


STRINGS.CHARACTER_TITLES.floe = "Ice witch"
STRINGS.CHARACTER_NAMES.floe = "Wloe"
STRINGS.CHARACTER_DESCRIPTIONS.floe = "*Loves cold\n*Has a special book\n*More vulnerable to fire"
STRINGS.CHARACTER_QUOTES.floe = "\"Give me your frozen heart!\""

STRINGS.CHARACTERS.FLOE = require "speech_floe"
return MakePlayerCharacter("floe", prefabs, assets, fn, start_inv)
