local assets=
{ 
    Asset("ANIM", "anim/frozen_book.zip"),

    Asset("ATLAS", "images/inventoryimages/frozen_book.xml"),
    Asset("IMAGE", "images/inventoryimages/frozen_book.tex"),
}

local prefabs = 
{
    "book_fx",
	"icespike_floe",
	"floeringfx",
}

function frozenrage(inst, reader)

    local num_ice =  26
    reader.components.health:DoDelta(-20,0,0)
	reader.components.temperature:SetTemperature(reader.components.temperature.current + 50)
    reader:StartThread(function()
        for k = 0, num_ice do

            local rad = math.random (15)
            local angle = k*((4*PI)/num_ice)
            local pos = Vector3(reader.Transform:GetWorldPosition()) + Vector3(rad*math.cos(angle), 0, rad*math.sin(angle))
--          inst:DoTaskInTime(0.1, function()
			SpawnPrefab("icespike_floe").Transform:SetPosition(pos:Get())
			--doeffects(inst, pos)
--			end)
            Sleep(math.random( .3, .5))
        end
	end)
	
	local fx4 = SpawnPrefab("floeringfx")
    fx4.entity:SetParent(reader.entity)
    fx4.Transform:SetPosition(0, 0.2, 0)

	local range = 30
    local pos2 = Vector3(reader.Transform:GetWorldPosition())
	local ents = TheSim:FindEntities(pos2.x,pos2.y,pos2.z, range)
    for k,v in pairs(ents) do
        if v.components.freezable and v ~= reader then
            v.components.freezable:AddColdness(20)
        end
    end

    return true
end

local function fn(colour)
	
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)
    
    anim:SetBank("book_maxwell")
    anim:SetBuild("frozen_book")
    anim:PlayAnimation("idle")
	
--	inst.fxcolour = {9/255, 9/255, 9/255}
	

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "frozen_book"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/frozen_book.xml"
	
	inst:AddComponent("inspectable")
    
 inst:AddComponent("book")
    inst.components.book.onread = frozenrage

    return inst
end

STRINGS.NAMES.FROZEN_BOOK = "Break the Ice"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.FROZEN_BOOK = {	
	"Key to my power",
	"I'll make them suffer!"
	 
}

return  Prefab("common/inventory/frozen_book", fn, assets, prefabs)